OpenShot Audio Library | OpenShotAudio: juce::ValueTreeSynchroniser Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0 |

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
juce::ValueTreeSynchroniser Class Referenceabstract

`#include <juce_ValueTreeSynchroniser.h>`

Inheritance diagram for juce::ValueTreeSynchroniser:

## Public Member Functions
| ValueTreeSynchroniser (const ValueTree &tree)
| ~ValueTreeSynchroniser () override
virtual void | stateChanged (const void *encodedChange, size_t encodedChangeSize)=0
void | sendFullSyncCallback ()
const ValueTree & | getRoot () noexcept

## Static Public Member Functions
static bool | applyChange (ValueTree &target, const void *encodedChangeData, size_t encodedChangeDataSize, UndoManager *undoManager)

## Detailed Description

This class can be used to watch for all changes to the state of a ValueTree, and to convert them to a transmittable binary encoding.

The purpose of this class is to allow two or more ValueTrees to be remotely synchronised by transmitting encoded changes over some kind of transport mechanism.

To use it, you'll need to implement a subclass of ValueTreeSynchroniser and implement the stateChanged() method to transmit the encoded change (maybe via a network or other means) to a remote destination, where it can be applied to a target tree.

Definition at line 45 of file juce_ValueTreeSynchroniser.h.

## Constructor & Destructor Documentation

## ◆ ValueTreeSynchroniser()

juce::ValueTreeSynchroniser::ValueTreeSynchroniser | ( | const ValueTree & | tree | ) |

Creates a ValueTreeSynchroniser that watches the given tree.

After creating an instance of this class and somehow attaching it to a target tree, you probably want to call sendFullSyncCallback() to get them into a common starting state.

Definition at line 95 of file juce_ValueTreeSynchroniser.cpp.

## ◆ ~ValueTreeSynchroniser()

juce::ValueTreeSynchroniser::~ValueTreeSynchroniser | ( |  | ) |
| override

Destructor.

Definition at line 100 of file juce_ValueTreeSynchroniser.cpp.

## Member Function Documentation

## ◆ applyChange()

bool juce::ValueTreeSynchroniser::applyChange | ( | ValueTree & | target,
|  | const void * | encodedChangeData,
|  | size_t | encodedChangeDataSize,
|  | UndoManager * | undoManager )
| static

Applies an encoded change to the given destination tree.

When you implement a receiver for changes that were sent by the stateChanged() message, this is the function that you'll need to call to apply them to the target tree that you want to be synced.

Definition at line 161 of file juce_ValueTreeSynchroniser.cpp.

Referenced by stateChanged().

## ◆ getRoot()

const ValueTree & juce::ValueTreeSynchroniser::getRoot | ( |  | ) |
| inlinenoexcept

Returns the root ValueTree that is being observed.

Definition at line 84 of file juce_ValueTreeSynchroniser.h.

## ◆ sendFullSyncCallback()

void juce::ValueTreeSynchroniser::sendFullSyncCallback | ( |  | ) |

Forces the sending of a full state message, which may be large, as it encodes the entire ValueTree.

This will internally invoke stateChanged() with the encoded version of the state.

Definition at line 105 of file juce_ValueTreeSynchroniser.cpp.

Referenced by stateChanged().

## ◆ stateChanged()

virtual void juce::ValueTreeSynchroniser::stateChanged | ( | const void * | encodedChange,
|  | size_t | encodedChangeSize )
| pure virtual

This callback happens when the ValueTree changes and the given state-change message needs to be applied to any other trees that need to stay in sync with it. The data is an opaque blob of binary that you should transmit to wherever your target tree lives, and use applyChange() to apply this to the target tree.

Referenced by sendFullSyncCallback().

The documentation for this class was generated from the following files:

- juce_ValueTreeSynchroniser.h
- juce_ValueTreeSynchroniser.cpp